// PEEditorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PEEditor.h"
#include "PEEditorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ERR_RW     "Error while accesing the file (READ/WRITE)."
#define ERR_PE     "No PE signature found.\nThis is file is not valid Win32 module."

char szPEOpenFilter[] = 
{
   "Executable Files (*.exe)|" "*.exe|"
   "Dynamic-Link Library Files (*.dll)|" "*.dll|"
   "ActiveX Control Files (*.ocx)|" "*.ocx|" 
   "All Files (*.*)|" "*.*||" 
};
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPEEditorDlg dialog

CPEEditorDlg::CPEEditorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPEEditorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPEEditorDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPEEditorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPEEditorDlg)
	DDX_Control(pDX, ID_APPLY, m_Apply);
	DDX_Control(pDX, ID_ADVANCED, m_Advanced);
	DDX_Control(pDX, ID_SECTION, m_SectionBtn);
	DDX_Control(pDX, ID_DIRECTORY, m_DirectoryBtn);
	DDX_Control(pDX, IDC_SIZE_OF_IMAGE, m_Szofimage);
	DDX_Control(pDX, IDC_IMAGE_BASE, m_ImgBase);
	DDX_Control(pDX, IDC_ENTRY_POINT, m_EntPoint);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPEEditorDlg, CDialog)
	//{{AFX_MSG_MAP(CPEEditorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_SECTION, OnSection)
	ON_BN_CLICKED(ID_DIRECTORY, OnDirectory)
	ON_BN_CLICKED(ID_BROWSE, OnBrowse)
	ON_BN_CLICKED(ID_EXIT, OnExit)
	ON_BN_CLICKED(ID_ABOUT, OnAbout)
	ON_BN_CLICKED(ID_APPLY, OnApply)
	ON_BN_CLICKED(ID_ADVANCED, OnAdvanced)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPEEditorDlg message handlers

BOOL CPEEditorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	pSysMenu->DeleteMenu(SC_SIZE, MF_BYCOMMAND);
    pSysMenu->DeleteMenu(SC_RESTORE, MF_BYCOMMAND);
    pSysMenu->DeleteMenu(SC_MAXIMIZE, MF_BYCOMMAND);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_EntPoint.SetLimitText(8);
	m_Szofimage.SetLimitText(8);
	m_ImgBase.SetLimitText(8);

	m_EntPoint.EnableWindow(FALSE);
	m_Szofimage.EnableWindow(FALSE);
	m_ImgBase.EnableWindow(FALSE);

	m_DirectoryBtn.EnableWindow(FALSE);
	m_SectionBtn.EnableWindow(FALSE);
	m_Advanced.EnableWindow(FALSE);
	m_Apply.EnableWindow(FALSE);

	CHAR buf[MAX_PATH];
	GetLongPathName(AfxGetApp()->m_lpCmdLine, buf, MAX_PATH);
	if (strlen(buf) != 0) LoadPEFile(buf);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPEEditorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPEEditorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPEEditorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPEEditorDlg::OnSection() 
{
	CSectionsInfoDlg dlg;
	dlg.DoModal();
}

void CPEEditorDlg::OnDirectory() 
{
	CDirectoryInfoDlg dlg;
	dlg.DoModal();
}

void CPEEditorDlg::OnExit() 
{
	if(IsOpen & TRUE) m_PEFile.Close();
	exit(0);
}

void CPEEditorDlg::OnAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

void CPEEditorDlg::OnAdvanced() 
{
	CAdvancedInfoDlg dlg;
	dlg.DoModal();
}

void CPEEditorDlg::OnApply() 
{
	CString tmp;
	if((MessageBox("Save PE Header informations?", "PE Header Editor", MB_YESNO | MB_ICONQUESTION)) == IDYES)
	{
		GetDlgItemText(IDC_ENTRY_POINT,   tmp);
		m_PEFile.PEHdr.EntryPointRVA = ConvFromHex(tmp);
	    GetDlgItemText(IDC_SIZE_OF_IMAGE, tmp);
		m_PEFile.PEHdr.ImageSize     = ConvFromHex(tmp);
	    GetDlgItemText(IDC_IMAGE_BASE,    tmp);
		m_PEFile.PEHdr.ImageBase     = ConvFromHex(tmp);

		m_PEFile.WritePEHeader();
	}
	else return;
}

void CPEEditorDlg::OnBrowse() 
{
	CFileDialog DlgOpen(TRUE, NULL,NULL,
		OFN_HIDEREADONLY, szPEOpenFilter);
	if(DlgOpen.DoModal()==IDOK) 
   	{
		if(IsOpen & TRUE) m_PEFile.Close();
		LoadPEFile(DlgOpen.GetPathName());
	}
}

VOID CPEEditorDlg::LoadPEFile(CString szFile)
{
		CString Caption;
	    m_OpenedPEFile = szFile;

		if(m_PEFile.Open(m_OpenedPEFile) != 0)
		{
			if (m_PEFile.IsPEFile() == FALSE)
			{
				AfxMessageBox(ERR_PE, MB_ICONERROR);
				return;
			}
	        if(m_PEFile.CheckAccess() == FALSE)
			{
				AfxMessageBox(ERR_RW, MB_ICONERROR);
				return;
			}

		    IsOpen = TRUE;

			Caption.Format("PE Header Editor - [%s]", m_OpenedPEFile);
		    SetWindowText(Caption);

		    m_PEFile.ReadPEHeader();
		    SetHeaderInfos();

		    SetDlgItemText(IDC_PE_FILE, m_OpenedPEFile);

		    m_EntPoint.EnableWindow(TRUE);
	        m_Szofimage.EnableWindow(TRUE);
	        m_ImgBase.EnableWindow(TRUE);

	        m_DirectoryBtn.EnableWindow(TRUE);
	        m_SectionBtn.EnableWindow(TRUE);
			m_Advanced.EnableWindow(TRUE);
			m_Apply.EnableWindow(TRUE);
		}
		else
		{
			AfxMessageBox(ERR_RW, MB_ICONERROR);
			return;
		}
}

VOID CPEEditorDlg::SetHeaderInfos(VOID)
{
	SetDlgItemText(IDC_ENTRY_POINT,   ConvToHEXStr(m_PEFile.PEHdr.EntryPointRVA));
	SetDlgItemText(IDC_SIZE_OF_IMAGE, ConvToHEXStr(m_PEFile.PEHdr.ImageSize));
	SetDlgItemText(IDC_IMAGE_BASE,    ConvToHEXStr(m_PEFile.PEHdr.ImageBase));
}
