// PEFile.cpp: implementation of the CPEFile class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PEFile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

DWORD MZ_SIGN = 0x5A4D;
DWORD PE_SIGN = 0x00004550;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPEFile::CPEFile()
{
	memset(&ObjEntry,    0, sizeof(ObjEntry));
	memset(&ExpDirTbl,   0, sizeof(ExpDirTbl));
	memset(&ImpDirEntry, 0, sizeof(ImpDirEntry));
	memset(&TLSDirTbl,   0, sizeof(TLSDirTbl));
	memset(&PEHdr,       0, sizeof(PEHdr));
}

CPEFile::~CPEFile()
{

}

BOOL CPEFile::Open(LPCTSTR szPEFile)
{
	return m_hPEFile.Open(szPEFile, CFile::modeReadWrite | CFile::typeBinary);
}

VOID CPEFile::Close()
{
	m_hPEFile.Close();
}

UINT CPEFile::ReadPEHeader(VOID)
{
	SeekToPEHeader();
	return m_hPEFile.Read(&PEHdr, sizeof(PEHeader));
}

UINT CPEFile::ReadObjectEntry(VOID)
{
	return m_hPEFile.Read(&ObjEntry, sizeof(ObjectEntry));
}

LONG CPEFile::SeekToPEHeader(VOID)
{
	DWORD nTemp;
	m_hPEFile.SeekToBegin();
	while(nTemp != PE_SIGN)
	{
		if (m_hPEFile.Read(&nTemp, sizeof(DWORD)) == 0) return 0;
	}
	return m_hPEFile.Seek(m_hPEFile.GetPosition()-4, CFile::begin);
}

LONG CPEFile::SeekToObjectEntry(VOID)
{
	return m_hPEFile.Seek(SeekToPEHeader() + sizeof(PEHdr), CFile::begin);
}

VOID CPEFile::WritePEHeader()
{
	SeekToPEHeader();
	m_hPEFile.Write(&PEHdr, sizeof(PEHeader));
	m_hPEFile.Flush();
}

VOID CPEFile::WriteObjectEntry(VOID)
{
	m_hPEFile.Write(&ObjEntry, sizeof(ObjectEntry));
	m_hPEFile.Flush();
}

BOOL CPEFile::IsPEFile(VOID)
{
	WORD tmp;
	m_hPEFile.SeekToBegin();
	m_hPEFile.Read(&tmp, sizeof(WORD));
	if(tmp & MZ_SIGN)
	{
		if(SeekToPEHeader() <= 0)
		{
			return FALSE;
		}else return TRUE;
	}return FALSE;
}

BOOL CPEFile::CheckAccess(VOID)
{
	if (GetFileAttributes(m_hPEFile.GetFilePath()) == FILE_ATTRIBUTE_READONLY)
	{
		return FALSE;
	}else return TRUE;
}
