// PEFile.h: interface for the CPEFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PEFILE_H__D2AEFEAE_64CF_11D6_8219_C39BEFFBD801__INCLUDED_)
#define AFX_PEFILE_H__D2AEFEAE_64CF_11D6_8219_C39BEFFBD801__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct
{
	 BYTE ObjectName[8];
	 DWORD VirtualSize;
	 DWORD SectionRVA;
	 DWORD PhysicalSize;
	 DWORD PhysicalOffset;
	 BYTE Reserved[10];
	 DWORD ObjectFlags;
}    ObjectEntry;

typedef struct
{
	 DWORD Flags;
	 DWORD TimeDateStamp;
	 WORD MajorVersio;
	 DWORD MinorVersion;
	 DWORD NameRVA;
	 DWORD OrdinalBase;
	 DWORD NumOfFunctions;
	 DWORD NumOfNamePointers;
	 DWORD AddressTableRVA;
	 DWORD NamePointersRVA;
	 DWORD OrdinalTableRVA;
}    ExportDirectoryTable;

typedef struct
{
	 DWORD ImportLookUp;
	 DWORD TimeDateStamp;
	 DWORD ForwardChain;
	 DWORD NameRVA;
	 DWORD AddresTableRVA;
}    ImportDirectoryEntry;


typedef struct
{
	 DWORD StartDataBlockVA;
	 DWORD EndDataBlockVA;
	 DWORD IndexVA;
	 DWORD CallBackTableVA;
}    TLSDirectoryTable;

typedef struct
{
     DWORD SignatureBytes;
	 WORD CPUType;
	 WORD NumOfSections;
	 DWORD TimeDateStamp;
	 DWORD PointerToCOFF;
	 DWORD COFFTableSize;
	 WORD NTHeaderSize;
	 WORD Flags;
	 WORD Magic;
	 BYTE LinkMajor;
	 BYTE LinkMinor;
	 DWORD SizeOfCode;
	 DWORD SizeOfInitData;
	 DWORD SizeOfUnInitData;
	 DWORD EntryPointRVA;
	 DWORD BaseOfCode;
	 DWORD BaseOfData;
	 DWORD ImageBase;
	 DWORD ObjectAlign;
	 DWORD FileAlign;
	 WORD OSMajor;
	 WORD OSMinor;
	 WORD USERMajor;
	 WORD USERMinor;
	 WORD SubSysMajor;
	 WORD SubSysMinor;
	 DWORD Reserved;
	 DWORD ImageSize;
	 DWORD HeaderSize;
	 DWORD FileChecksum;
	 WORD SubSystem;
	 WORD DLLFlags;
	 DWORD StackReserveSize;
	 DWORD StackCommitSize;
	 DWORD HeapReserveSize;
	 DWORD HeapComitSize;
	 DWORD LoaderFlags;
	 DWORD NumOfRVAandSizes;
	 DWORD ExportTableRVA;
	 DWORD ExportDataSize;
	 DWORD ImportTableRVA;
	 DWORD ImportDataSize;
	 DWORD ResourceTableRVA;
	 DWORD ResourceDataSize;
	 DWORD ExceptionTableRVA;
	 DWORD ExceptionDataSize;
	 DWORD SecurityTableRVA;
	 DWORD SecurityDataSize;
	 DWORD FixUpTableRVA;
	 DWORD FixUpDataSize;
	 DWORD DebugTableRVA;
	 DWORD DebugDataSize;
	 DWORD ImageDescriptionRVA;
	 DWORD DescriptionDataSize;
	 DWORD MachineSpecificRVA;
	 DWORD MachnineDataSize;
	 DWORD TLSRVA;
	 DWORD TLSDataSize;
	 DWORD LoadConfigRVA;
	 DWORD LoadConfigDataSize;
	 BYTE Reserved01[8];
	 DWORD IATRVA;
	 DWORD IATDataSize;
	 BYTE Reserved02[8];
	 BYTE Reserved03[8];
	 BYTE Reserved04[8];
} PEHeader;


class CPEFile  
{
public:
	virtual BOOL CheckAccess(VOID);
	virtual BOOL IsPEFile(VOID);
	CPEFile();
	virtual ~CPEFile();
	virtual UINT ReadObjectEntry(VOID);
	virtual VOID WriteObjectEntry(VOID);
	virtual LONG SeekToObjectEntry(VOID);
	virtual LONG SeekToPEHeader(VOID);
	virtual UINT ReadPEHeader(VOID);
	virtual VOID WritePEHeader(VOID);
	virtual VOID Close(VOID);
	virtual BOOL Open(LPCTSTR szPEFile);

	ObjectEntry          ObjEntry;
    ExportDirectoryTable ExpDirTbl;
    ImportDirectoryEntry ImpDirEntry;
    TLSDirectoryTable    TLSDirTbl;
    PEHeader             PEHdr;
protected:
	CStdioFile m_hPEFile;
};

#endif // !defined(AFX_PEFILE_H__D2AEFEAE_64CF_11D6_8219_C39BEFFBD801__INCLUDED_)
